package io.xjar;

import java.io.OutputStream;
import java.io.InputStream;
import java.io.IOException;
import java.util.jar.Attributes;
import java.util.jar.Manifest;
import io.xjar.jar.XJarDecryptor;
import io.xjar.boot.XBootDecryptor;
import java.util.jar.JarFile;
import java.io.File;
import io.xjar.key.XKey;
import org.apache.commons.compress.archivers.jar.JarArchiveEntry;

public class XSmartDecryptor extends XEntryDecryptor<JarArchiveEntry> implements XDecryptor, XConstants
{
    public XSmartDecryptor(final XDecryptor xDecryptor) {
        super(xDecryptor);
    }
    
    public XSmartDecryptor(final XDecryptor xDecryptor, final XEntryFilter<JarArchiveEntry> filter) {
        super(xDecryptor, filter);
    }
    
    @Override
    public void decrypt(final XKey key, final File src, final File dest) throws IOException {
        try (JarFile jar = new JarFile(src, false)) {
            final Manifest manifest = jar.getManifest();
            final Attributes attributes = manifest.getMainAttributes();
            final String version = attributes.getValue("Spring-Boot-Version");
            final XDecryptor decryptor = (XDecryptor)((version != null) ? new XBootDecryptor(this.xDecryptor, (XEntryFilter)this.filter) : new XJarDecryptor(this.xDecryptor, (XEntryFilter)this.filter));
            decryptor.decrypt(key, src, dest);
        }
    }
    
    @Override
    public void decrypt(final XKey key, final InputStream in, final OutputStream out) throws IOException {
        throw new UnsupportedOperationException();
    }
}
